use v6.d;

sub read_sequences($file) {
    my %sequences;
    my $header = "";
    for $file.IO.lines.map(*.trim-trailing) {
        if .starts-with(">") {
            $header = .substr(1,);
        }
        else {
            %sequences{$header}.push: $_;
        }
    }
    %sequences{$_} .= join for %sequences.keys;
    return %sequences;
}

sub count_bases($file) {
    my %sequences = read_sequences($file);
    for (sort keys %sequences) {
        my $sequence = %sequences{$_};
        say "$_ (", chars($sequence), " bases):";
        say $sequence.comb.Bag.hash;
    }
}

sub MAIN($file = "") {
    if ($file) {
        count_bases($file);
    }
    else {
        say "Usage: basecount <filename>";
    }
}
